unit sybradiobutton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,dsgnintf,sybtable;

type SybObjectname = string[30];
type string1 = string[1];

type
  Tsybobjectproperty = class(TStringProperty)
  public
    procedure GetValues(TheProc: TGetStrProc); override;
    function getattributes:Tpropertyattributes; override;
  end;

type
  TSybRadioButton = class(TRadioButton)
  private
    { Private declarations }
    fdatatype     :SybObjectname;
    ftablename    :SybObjectname;
    ftable        :tsybtable;
    fdatafield    :SybObjectname;
    fisprimarykey :boolean;
    procedure Setdatatype(Value :SybObjectname);
    procedure Settablename(Value :SybObjectname);
    procedure Setdatafield(Value :SybObjectname);
    function getvalue:string1;
    procedure setvalue(value:string1);
    procedure Setisprimarykey(Value :boolean);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor destroy; override;
    procedure setname(const NewName:Tcomponentname); override;
  published
    { Published declarations }
    property Datatype:SybObjectname read fdatatype write setdatatype;
    property TableName :SybObjectname read FTableName write settablename;
    property DataField :SybObjectname read fdatafield write setdatafield;
    property Value:string1 read getvalue write setvalue;
    property IsPrimaryKey:boolean read fisprimarykey write setIsPrimaryKey stored false;
  end;

procedure Register;
var from_create :boolean;

implementation
uses sybase_components;

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(SybObjectname),TSybRadioButton,'',Tsybobjectproperty);
  RegisterComponents('Sybase DBLIB', [TSybRadioButton]);
end;

constructor TSybRadioButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  setdatatype('bit');
  from_create:=true;
  fIsPrimaryKey:=false;
  if fieldslist = nil then
  begin
    FieldsList:=TList.create;
  end;
end;

destructor TSybRadioButton.destroy;
var thisform  :tform;
    i,j       :smallint;
    asybtable :tsybtable;
begin
  thisform:=tform(owner);
  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=tablename) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.deletefield(name);
      break;
    end;
  end;
  fieldslist.remove(self);
  inherited destroy;
end;

procedure TSybRadioButton.Setdatatype(Value :SybObjectname);
begin
  fdatatype:=value;
end;

procedure TSybRadioButton.Setisprimarykey(Value :boolean);
begin
  fisprimarykey:=value;
end;

function TSybRadioButton.getvalue:string1;
begin
  if checked then
    result:='1'
  else
    result:='0';
end;

procedure TSybRadioButton.setvalue(value:string1);
begin
  if value = '1' then
    checked:=true
  else
    checked:=false;  
end;

procedure TSybRadioButton.setname(const NewName:Tcomponentname);
var oldname :Tcomponentname;
    thisform  :tform;
    i         :smallint;
    asybtable :tsybtable;
begin
  oldname:=name;
  thisform:=tform(owner);
  inherited setname(NewName);
  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=tablename) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.deletefield(oldname);
      asybtable.addfield(name);
      break;
    end;
  end;

  if fieldslist.indexof(self) = -1 then
    fieldslist.add(self)
  else
  begin
    fieldslist.items[fieldslist.indexof(self)]:=self;
  end;
end;

procedure TSybRadioButton.Setdatafield(Value :SybObjectname);
begin
  fdatafield:=value;
end;

procedure TSybRadioButton.Settablename(Value :SybObjectname);
var thisform  :tform;
    i,j       :smallint;
    asybtable :tsybtable;
begin
  thisform:=tform(owner);

  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=tablename) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.deletefield(name);
      break;
    end;
  end;

  Ftablename:=value;

  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=value) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.addfield(name);
      break;
    end;
  end;

end;

procedure Tsybobjectproperty.GetValues(TheProc: TGetStrProc);
var i,j       :integer;
    thisform  :tform;
    teditf    :TSybRadioButton;
    nm        :string;
    asybtable :tsybtable;

begin
  teditf:=TSybRadioButton(getcomponent(0));
  thisform:=tform(teditf.owner);
  if getname = 'TableName' then
  begin
    for i := 0 to thisform.ComponentCount - 1 do
    begin
      with thisform.Components[i] do { as TControl) do}
      begin
        if thisform.Components[i] is TSybTable then
         theproc(thisform.Components[i].name);
      end;
    end;
  end;
  if getname = 'Datatype' then
  begin
    theproc('binary');
    theproc('bit');
    theproc('char');
    theproc('datetime');
    theproc('decimal');
    theproc('float');
    theproc('int');
    theproc('money');
    theproc('varchar');
  end;
  if getname = 'DataField' then
  begin
    for i := 0 to thisform.ComponentCount - 1 do
    begin
      if (thisform.Components[i] is TSybTable)
        and (thisform.Components[i].name=teditf.tablename) then
      begin
        asybtable:=tsybtable(thisform.Components[i]);
        for j:=1 to asybtable.datafieldscount do
          theproc(asybtable.datafields[j]);
      end;
    end;

  end;

end;

function Tsybobjectproperty.getattributes:Tpropertyattributes;
begin
  Result := [paValueList,paAutoUpdate,paMultiSelect];
end;

end.
